
import time

# Function to process a batch of numbers
def process_batch(batch):
    for number in batch:
        squared = number * number
        print(f"Processing number: {number}, squared: {squared}")

def main():
    batch = []
    batch_size = 5  # Define the size of each batch

    # Simulating incoming numbers to be processed
    for i in range(1, 21):
        batch.append(i)

        # When the batch reaches the defined size, process it
        if len(batch) == batch_size:
            print(f"Processing a batch of {batch_size} numbers...")
            process_batch(batch)
            batch.clear()  # Clear the batch after processing
        
        # Simulate some delay for the next number
        time.sleep(0.1)

    # Process any remaining numbers in the batch
    if batch:
        print(f"Processing the final batch of {len(batch)} numbers...")
        process_batch(batch)

if __name__ == "__main__":
    main()
